# TODO: to zadanie bardziej pasuje do function_parameters
"""
* Assignment: Function Arguments Divide
* Type: class assignment
* Complexity: easy
* Lines of code: 4 lines
* Time: 3 min

English:
    1. Define function `divide`:
        a. parameter `a: int` - first number (required)
        b. parameter `b: int` - second number (required)
        c. return result of division of both arguments
    2. If division cannot be made raise `ValueError`
       with message "Argument `b` cannot be zero"
    3. Run doctests - all must succeed

Polish:
    1. Zdefiniuj funkcję `divide`:
        a. parametr `a: int` - pierwsza liczba (wymagany)
        b. parametr `b: int` - druga liczba (wymagany)
        c. zwróć wynik dzielenia obu argumentów
    2. Jeżeli dzielenie nie może być wykonane podnieś `ValueError`
       z komunikatem "Argument `b` cannot be zero"
    3. Uruchom doctesty - wszystkie muszą się powieść

Tests:
    >>> import sys; sys.tracebacklimit = 0
    >>> from inspect import isfunction

    >>> assert divide is not Ellipsis, \
    'Write solution inside `divide` function'
    >>> assert isfunction(divide), \
    'Object `divide` must be a function'

    >>> divide(4, 0)
    Traceback (most recent call last):
    ValueError: Argument `b` cannot be zero

    >>> divide(4, 2)
    2.0
"""

# Define function `divide`:
# - parameter `a: int` - first number
# - parameter `b: int` - second number
# - return result of division of both arguments
# If division cannot be made raise `ValueError`
# with message "Argument `b` cannot be zero"
# type: Callable[[int, int], float]
def divide(a, b):
    ...


# Solution
def divide(a, b):
    if b == 0:
        raise ValueError('Argument `b` cannot be zero')
    return a / b
